import { transformSync } from '@babel/core';
import cloneDeep from "@dword-design/functions/dist/clone-deep.js";
import packageName from 'depcheck-package-name';
export default (opts => {
  const babelOpts = cloneDeep(opts.babel);
  babelOpts.presets = babelOpts.presets || [];
  babelOpts.plugins = babelOpts.plugins || [];
  babelOpts.presets = babelOpts.presets.filter(preset => [].concat(preset)[0] !== '@babel/preset-env');
  babelOpts.presets.push(packageName`@babel/preset-env`);
  babelOpts.plugins.push(packageName`babel-plugin-transform-import-meta`);
  try {
    return {
      code: transformSync(opts.source, {
        filename: opts.filename,
        ...babelOpts
      }).code
    };
  } catch (error) {
    var _error$code, _error$loc, _error$loc2, _error$message;
    return {
      code: `exports.__JITI_ERROR__ = ${JSON.stringify({
        code: (_error$code = error.code) === null || _error$code === void 0 ? void 0 : _error$code.replace('BABEL_', '').replace('PARSE_ERROR', 'ParseError'),
        column: ((_error$loc = error.loc) === null || _error$loc === void 0 ? void 0 : _error$loc.column) || 0,
        filename: opts.filename,
        line: ((_error$loc2 = error.loc) === null || _error$loc2 === void 0 ? void 0 : _error$loc2.line) || 0,
        message: (_error$message = error.message) === null || _error$message === void 0 ? void 0 : _error$message.replace('/: ', '').replace(/\(.+\)\s*$/, '')
      })}`,
      error
    };
  }
});